function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { action } from '@priceline/storybook-preset';
import { Box, Button, Text } from 'pcln-design-system';
import { Menu, MenuItem } from 'pcln-menu';
import PropTypes from 'prop-types';
import React from 'react';
import styled from 'styled-components';
import { Modal, ModalHeader, ScrollLock, SmallModalHeader } from '../src';
import { currencies } from './mockData';
const StyledModal = styled(Modal).withConfig({
  displayName: "Modalstories__StyledModal",
  componentId: "sc-14z4vs9-0"
})(["height:", ";"], props => props.height);
const CUSTOM_ANIMATION = transitionState => `
  transform: translateY(-122%);
  transition: transform 0.3s linear;
  ${transitionState === 'entered' ? `transform: translateY(0%);` : ''}
`;
class ModalStory extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: props.isOpen
    };
    this.scrollLock = new ScrollLock();
  }
  static propTypes = {
    isOpen: PropTypes.bool,
    lock: PropTypes.bool
  };
  render() {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        height: '1500px'
      }
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: () => {
        if (this.props.lock) {
          this.scrollLock.on();
        }
        this.setState({
          isOpen: true
        });
      }
    }, "Open"), /*#__PURE__*/React.createElement(StyledModal, _extends({
      ariaLabel: "Storybook modal.",
      isOpen: this.state.isOpen,
      onClose: () => {
        this.setState({
          isOpen: false
        });
        if (this.props.lock) {
          this.scrollLock.off();
        }
      }
    }, this.props), /*#__PURE__*/React.createElement("div", {
      style: {
        height: '1000px'
      }
    }, "Content with 1000px height")));
  }
}
export default {
  title: 'pcln-modal/Modal',
  component: Modal
};
export const Raw = () => /*#__PURE__*/React.createElement(ModalStory, {
  width: ['100px', '200px', '500px'],
  disableCloseButton: true
});
export const WithSmallModalHeader = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['80vw', '400px', '500px']
});
WithSmallModalHeader.story = {
  name: 'With SmallModalHeader'
};
export const WithModalHeader = () => {
  // Generate content to demonstrate a scrollable <body>
  const contentLines = [...Array(100).keys()];
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h1", null, "Scroll down to open modal"), contentLines.map((i, idx) => /*#__PURE__*/React.createElement("div", {
    key: idx
  }, "Line ", idx)), /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(ModalHeader, {
      title: "Modal title",
      onClose: action('Modal closed!')
    }),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  }));
};
export const WithSmallModalHeaderAndWhiteBackgroundModalHeaderWithSetTextStyle = () => {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(SmallModalHeader, {
      bg: null,
      color: "primary.base"
    }), /*#__PURE__*/React.createElement(ModalHeader, {
      bg: null,
      color: "background.lightest",
      onClose: action('Modal closed!'),
      pt: 2,
      textStyle: "heading4",
      title: "Modal title"
    })),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  });
};
export const WithOverflow = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['80vw', '400px', '500px'],
  enableOverflow: true
});
export const WithOverflowAndDropdown = () => /*#__PURE__*/React.createElement(StyledModal, {
  ariaLabel: "Storybook modal.",
  isOpen: true,
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  height: "100px"
}, /*#__PURE__*/React.createElement(Menu, {
  idx: "currency-selector",
  buttonNode: /*#__PURE__*/React.createElement("div", null, "open"),
  size: "twoColumns"
}, currencies.map((currency, index) => {
  const selected = 'USD' === currency.code;
  return /*#__PURE__*/React.createElement(MenuItem, {
    key: index,
    selected: selected
  }, /*#__PURE__*/React.createElement(Text, {
    regular: true,
    width: 32,
    textAlign: "center",
    mr: 3
  }, currency.symbol), /*#__PURE__*/React.createElement(Text, {
    regular: true
  }, currency.label));
})));
export const WithOverflowAndTallContent = () => /*#__PURE__*/React.createElement(StyledModal, {
  ariaLabel: "Storybook modal.",
  isOpen: true,
  header: /*#__PURE__*/React.createElement(ModalHeader, {
    onClose: action('Modal closed!')
  }),
  height: "100px",
  enableOverflow: true,
  disableCloseButton: true
}, /*#__PURE__*/React.createElement(Box, {
  color: "primary",
  height: "500px"
}, "Priceline"));
export const WithImagemodeAndColorful = () => /*#__PURE__*/React.createElement(ModalStory, {
  bg: "orange",
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['100px', '200px', '500px'],
  imgMode: true,
  disableCloseButton: true
});
export const RoundedModalWithHeader = () => /*#__PURE__*/React.createElement(ModalStory, {
  bg: "orange",
  header: /*#__PURE__*/React.createElement(ModalHeader, {
    title: "Priceline"
  }),
  width: ['100px', '200px', '500px'],
  imgMode: true,
  disableCloseButton: true
});
WithImagemodeAndColorful.story = {
  name: 'With imagemode and colorful'
};
export const WithCustomAnimation = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['100px', '200px', '500px'],
  dialogAnimation: CUSTOM_ANIMATION,
  verticalAlignment: "top"
});
WithCustomAnimation.story = {
  name: 'With custom animation'
};
export const ZeroTimeout = () => /*#__PURE__*/React.createElement(ModalStory, {
  disableCloseButton: true,
  width: ['100px', '200px', '500px'],
  timeout: 0
});